/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */

package gpttw;

import java.io.*;

import ec.*;
import ec.gp.koza.*;
import ec.util.*;

public class GPTTWStatistics extends KozaStatistics {
    public static final String P_SERIALIZATION = "individual";
    public static final String DEFAULT_FILENAME = "bestOfRun.ser";

    protected String serialized;

    public void setup(final EvolutionState state, final Parameter base) {
        super.setup(state, base);

        // Should we serialize out the best_of_run?
        serialized =
            state.parameters.getStringWithDefault(new Parameter(P_SERIALIZATION), null);

        if (serialized == null)
            serialized = DEFAULT_FILENAME;
    }

    public void finalStatistics(final EvolutionState state,
                                final int result) {

        // print out the other statistics
        super.finalStatistics(state, result);

        // we have only one population
        ((Problem) (state.evaluator.p_problem.protoCloneSimple())).describe(new Individual[] {
            best_of_run
        }, state, 0, statisticslog, Output.V_NO_GENERAL);

        if (serialized != null) {
            try {
                FileOutputStream out = new FileOutputStream(serialized);
                ObjectOutputStream outs = new ObjectOutputStream(out);

                outs.writeObject(best_of_run);
                outs.flush();

                outs.close();
                out.close();
            }
            catch (IOException e) {
                state.output.fatal("Serialization failure " + e);
            }
        }
    }

}

