
/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */

package gpttw.func;

import ec.*;
import ec.gp.*;
import ec.util.*;

import gpttw.*;


public abstract class BasicIf extends GPNode implements TankConstants {

    public abstract String toString();

    public void checkConstraints(final EvolutionState state, final int tree,
                                 final GPIndividual typicalIndividual,
                                 final Parameter individualBase) {

        super.checkConstraints(state, tree, typicalIndividual,
                               individualBase);

        if (children.length != 2)
            state.output.error("Incorrect number of children for node "
                               + toStringForError() + " at "
                               + individualBase);
    }

    public void eval(final EvolutionState state, final int thread,
                     final GPData input, final ADFStack stack,
                     final GPIndividual individual, final Problem problem) {

        if (condition((GPTTW) problem)) {
            children[0].eval(state, thread, input, stack, individual, problem);
        }
        else {
            children[1].eval(state, thread, input, stack, individual, problem);
        }
    }

    protected abstract boolean condition(GPTTW gpttw);
}
