package jessttw;

import jess.*;
import ToyTank.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class IndividualBrain implements Brain {
    public static final String SCRIPT = "SCRIPT";

    private ReteConnection brain;

    public IndividualBrain() {

        Rete rete = new Rete();

        jess.Main m = new jess.Main();
        m.initialize(new String[0], rete);

        String filename = System.getProperty(SCRIPT);
        if (filename == null) {
            throw new RuntimeException("Property SCRIPT is undefined");
        }

        try {
            rete.executeCommand("(batch " + filename + ")");
        }
        catch (JessException e) {
            throw new RuntimeException("Internal error: " + e);
        }

        brain = new ReteConnection(rete);
    }

    public void sensor(TankSensor t) {
        brain.sensor(t);
    }

    public void action(TankAction t) {
        brain.action(t);
    }

    public void restart() {
        brain.restart();
    }

    public void stop() {

        // Ok
    }

    public void close() {

        // Ok
    }

    public void close(int finalGap) {

        // Ok
    }
}