/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package jessttw;

import java.io.*;
import java.net.*;

import ToyTank.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class TTWConnectionHandler implements Runnable {

    private static TTWConnectionHandler onlyInstance;

    public ReteConnection reteConnection;

    public String hostname;
    public String port;
    public String name;
    public String r;
    public String g;
    public String b;

    public TTWConnectionHandler(String hostname, String port, String name,
                                String r, String g, String b) {

        if (onlyInstance != null)
            throw new RuntimeException("An instance of TTWConnectionHandler is already up and running");

        this.hostname = hostname;
        this.port = port;
        this.name = name;
        this.r = r;
        this.g = g;
        this.b = b;

        reteConnection = new ReteConnection(Main.rete);

        onlyInstance = this;

        (new Thread(this)).start();
    }

    public void run() {

        TTWProtocol protocol = null;
        Socket socket = null;
        PrintStream outStream = null;
        BufferedReader inStream = null;

        String command = null;

        try {

            // Establish connection
            socket = new Socket(hostname, Integer.valueOf(port).intValue());
            inStream =
                new BufferedReader(new InputStreamReader(socket.getInputStream()));
            outStream =
                new PrintStream(new BufferedOutputStream(socket.getOutputStream(), 1024),
                                false);

            protocol = new TTWProtocol(inStream, outStream);

            int rVal = Integer.valueOf(r).intValue();
            int gVal = Integer.valueOf(g).intValue();
            int bVal = Integer.valueOf(b).intValue();

            protocol.writeDescription(name, rVal, gVal, bVal);


            // Go

            while (true) {
                command = protocol.readCommand();

                if (protocol.isStopCommand(command)) {

                    // Ok.
                }
                else if (protocol.isRestartCommand(command)) {

                    reteConnection.restart();
                }
                else if (protocol.isCloseCommand(command)) {
                    return;
                }
                else if (protocol.isSensorCommand(command)) {
                    reteConnection.sensor(protocol.readSensor(command));
                    protocol.writeAction(reteConnection);
                }
                else
                    throw new RuntimeException("Protocol error");
            }
        }
        catch (Exception e) {
            e.printStackTrace();

            return;
        }
        finally {
            onlyInstance = null;

            try {
                protocol.close();
                socket.close();
            }
            catch (IOException e) {
                e.printStackTrace();
            }

            System.out.println();
            System.out.println("Connection closed");
            System.out.println();
        }
    }

}

