/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Physical objects with spacial information, tick movement,
 * and display systems.
 * 
 * Author	Matthew Caryl
 * Created 13.12.96
 * 
 * Although under copywrite to the author (Matthew Caryl)
 * this code can be copied and modified for non-commercial
 * purposes as long as any derivatives contain this condition.
 */

package ADT;

import java.awt.*;

public interface Physical {

    // positional systems
    public int[][][] outline();
    public Rectangle bounds();
    public int radius();
    public int x();
    public int y();
    public void set(int x, int y);
    public boolean moved();

    // collision system
    public void collision(boolean first);
    public void collision(Physical p, boolean first);

    // tick movement
    public void sensor();
    public void action();
    public void tick();

    // display system
    public void erase(Graphics g);
    public void paint(Graphics g);
}

