/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * AI Tank World
 *
 * Applet that controls simulation.
 *
 * Author  Matthew Caryl
 * Created 30.10.96
 *
 * Although under copywrite to the author (Matthew Caryl)
 * this code can be copied and modified for non-commercial
 * purposes as long as any derivatives contain this condition.
 *
 * Modified: pmarco@ipvvis.unipv.it
 */

package ToyTank;

import java.awt.*;
import java.applet.Applet;


// A transcript window
public class WorldTranscript extends Frame {
    final static int MAX_ROWS = 256;

    World world;
    Button startButton;
    Button resetButton;
    TextArea textArea;
    int rows;

    public WorldTranscript(World w) {
        world = w;

        Panel bottomPanel = new Panel();
        Panel centerPanel = new Panel();

        setLayout(new BorderLayout());

        // Add small things at the bottom of the window.
        startButton = new Button("Start");
        bottomPanel.add(startButton);

        resetButton = new Button("Reset");
        bottomPanel.add(resetButton);

        add("South", bottomPanel);

        // Add big things to the center area of the window.
        centerPanel.setLayout(new GridLayout(1, 1));

        textArea = new TextArea("- Transcript Begin -\n", 20, 40);

        textArea.setEditable(false);
        rows = 0;
        centerPanel.add("Center", textArea);
        add("Center", centerPanel);
    }

    public synchronized void append(String text) {
        if (rows >= MAX_ROWS) {
            textArea.setText("");
            rows = 0;
        }

        ++rows;
        textArea.append(text);
    }

    public boolean action(Event event, Object arg) {

        if (event.target == startButton) {

            // Ok. Start animation
            startButton.setEnabled(false);
            world.startAnimation();
        }

        if (event.target == resetButton) {

            // Ok. Start animation
            world.resetAnimation();
            startButton.setEnabled(true);
        }

        return true;
    }

    // This hoplelessy deprecated (oh well ...)
    public boolean handleEvent(Event event) {

        // Refuse destroying this (shut down the applet insted)
        if (event.id == Event.WINDOW_DESTROY) {
            return true;
        }
        else {
            return super.handleEvent(event);
        }
    }

}

