/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package evision.ec.app.fibonacci;


import ec.*;
import ec.util.*;
import ec.gp.koza.KozaFitness;

import evision.ec.np.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class Fibonacci extends NPProblem {

    // s(n) = s(n - 1) + s(n - 2)
    // 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233, 377, 610, 987 ...
    public static int[] sequence = {
        1, 2, 3, 5, 8, 13, 21, 34, 55
    };

    public void setup(final EvolutionState state, final Parameter base) {

        // very important, remember this
        super.setup(state, base);

        data = new FibonacciData();
    }

    public void evaluate(final EvolutionState state, final Individual[] ind,
                         final int threadnum) {


        for (int i = 0; i < ind.length; i++) {
            if (!ind[i].evaluated) {
                int value = 0;
                int hits = 0;

                float distance = 0;

                // reset
                ((NPIndividual) ind[i]).graphs[0].resetGraph(state,
                        threadnum);

                for (int j = 0; j < sequence.length; j++) {

                    // evaluate the individual
                    ((FibonacciData) data).resetData();
                    ((NPIndividual) ind[i]).graphs[0].eval(state, threadnum,
                                                           data, null,
                                                           ((NPIndividual) ind[i]),
                                                           this);

                    // Compute distance
                    value = ((FibonacciData) data).value;

                    if (value == sequence[j]) {
                        ++hits;
                    }
                    else {
                        distance += (float) Math.abs(sequence[j] - value)
                                    / sequence[j];
                    }
                }

                // the fitness better be KozaFitness!
                KozaFitness f = ((KozaFitness) ind[i].fitness);

                f.hits = hits;

                f.setFitness(state, distance);

                ind[i].evaluated = true;
            }
        }
    }

    public void describe(final Individual[] ind, final EvolutionState state,
                         final int threadnum, final int log,
                         final int verbosity) {
        state.output.println("\n\nBest Individual's Map\n=====================",
                             verbosity, log);

    }

}

