/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package evision.ec.np;

import ec.*;
import ec.util.*;

/** Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */


 /**
 * NPData is the parent class of data shared across NPNodes.
 * If performed correctly, there need be only one NPData instance
 * ever created in the evaluation of many individuals.
 * <p><b>Default Base</b><br>
 * np.data
 */


public abstract class NPData implements Prototype {
    static final long serialVersionUID = -6099548671214045348L;

    public static final String P_NPDATA = "data";

    /**
     * Modifies gpd so that gpd is equivalent to us. You may
     * safely assume that gpd is of the same class as we are.
     */
    public abstract NPData copyTo(final NPData gpd);

    public Parameter defaultBase() {
        return NPDefaults.base().push(P_NPDATA);
    }

    public void setup(final EvolutionState state, final Parameter base) {}

    public Object protoClone() throws CloneNotSupportedException {
        return super.clone();
    }

    public final Object protoCloneSimple() {
        try {
            return protoClone();
        }
        catch (CloneNotSupportedException e) {
            throw new InternalError();
        }   // never happens
     }

}

