/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package evision.ec.np;

import java.util.*;

import ec.*;
import ec.util.*;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

/**
 * NPFuncInfo is a Prototype wrapper object which holds a single NPNode
 * and is stored in arrays keyed by the NPNode's type.  The purpose of
 * NPFuncInfo is to provide a hook for future development to add "facts"
 * about NPNode prototypes as they're stored away waiting to be cloned
 * into trees, without having to modify NPNode itself, which would
 * be brittle since it's the superclass of all NP function nodes.
 *
 * <p><b>Default Base</b></br>
 * np.func-info
 *
 */

public class NPFuncInfo implements Prototype {
    static final long serialVersionUID = 8050316894413666771L;

    public static final String P_NPFUNCINFO = "func-info";

    /**
     * The stored node
     */
    public NPNode node;

    public Parameter defaultBase() {
        return NPDefaults.base().push(P_NPFUNCINFO);
    }

    public void setup(final EvolutionState state, final Parameter base) {

        // presently, nothing.
        node = null;// be on the safe side

        return;
    }

    /**
     * Override this to rearrange hash's contents as you see fit.
     * hash contains arrays of NPFuncInfo objects of your class,
     * keyed by a NPType (there's one array for every NPType there is).
     * For example, you might sort elements in each array by some
     * probability of occurrence, if you've subclassed NPFuncInfo to
     * work with a NPNodeGenerator of some sort that requires this.
     * This method only gets called on prototypes, though it might get
     * called more than once, and with different values for hash.
     * Return the resultant hashtable (or if you've changed it to
     * some other hashtable, return that).
     */

    public Hashtable arrange(final Hashtable hash) {

        // presently, nothing
        return hash;
    }

    public Object protoClone() throws CloneNotSupportedException {
        return super.clone();
    }

    public final Object protoCloneSimple() {
        try {
            return protoClone();
        }
        catch (CloneNotSupportedException e) {
            throw new InternalError();
        }   // never happens
     }

}

