/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package evision.ec.np;

import ec.*;
import ec.util.*;

/**
 * NPMemory is the parent class of data private to each NPNode.
 * <p><b>Default Base</b><br>
 * np.memory
 *
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */


public abstract class NPMemory implements Prototype {
    static final long serialVersionUID = -1292633423501736600L;

    public static final String P_NPMEMORY = "memory";

    public Parameter defaultBase() {
        return NPDefaults.base().push(P_NPMEMORY);
    }

    /**
     * Modifies gpd so that gpd is equivalent to us. You may
     * safely assume that gpd is of the same class as we are.
     */
    public abstract NPMemory copyTo(final NPMemory gpd);

    /**
     * Reset node memory, e.g. after a previous execution
     */
    public abstract void resetMemory(final EvolutionState state,
                                     final int thread);

    public void setup(final EvolutionState state, final Parameter base) {}

    public Object protoClone() throws CloneNotSupportedException {
        return super.clone();
    }

    public final Object protoCloneSimple() {
        try {
            return protoClone();
        }
        catch (CloneNotSupportedException e) {
            throw new InternalError();
        }   // never happens
     }

}

