/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package evision.ec.np.breed;

import java.io.Serializable;

import ec.*;
import ec.util.*;

import evision.ec.np.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class NPReproductionPipeline extends BreedingPipeline {
    static final long serialVersionUID = 7181207269347496437L;

    public static final String P_REPRODUCE = "reproduce";
    public static final int INDS_PRODUCED = 1;
    public static final int NUM_SOURCES = 1;

    public Parameter defaultBase() {
        return NPBreedDefaults.base().push(P_REPRODUCE);
    }

    public int numSources() {
        return NUM_SOURCES;
    }

    /**
     * Returns 1
     */
    public int typicalIndsProduced() {
        return INDS_PRODUCED;
    }


    public int produce(final int min, final int max, final int start,
                       final int subpopulation, final Individual[] inds,
                       final EvolutionState state,
                       final int thread) throws CloneNotSupportedException {

        // how many individuals should we make?
        int n = INDS_PRODUCED;

        if (n < min)
            n = min;

        if (n > max)
            n = max;

            // grab n individuals from our source and stick 'em right into inds.
            // we'll modify them from there

        sources[0].produce(n, n, start, subpopulation, inds, state, thread);

        for (int q = start; q < n + start; q++) {

            // Read individual
            NPIndividual ind = (NPIndividual) inds[q];

            if (!(sources[0] instanceof BreedingPipeline)) {

                // Ok, deep clone it
                ind = (NPIndividual) ind.protoClone();
            }
            // add the new individual, replacing its previous source

            // Debugging
            ind.verifyIndividual(true);

            inds[q] = ind;
        }

        return n;
    }


}

