/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package evision.ec.util;

import java.io.*;
import java.util.Vector;

import ec.*;
import ec.gp.*;

import evision.ec.np.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public abstract class IndividualWriter extends PrintWriter {

    // Just re-assert constructors

    public IndividualWriter(Writer out) {
        super(out);
    }

    public IndividualWriter(Writer out, boolean autoFlush) {
        super(out, autoFlush);
    }

    public IndividualWriter(OutputStream out) {
        super(out);
    }

    public IndividualWriter(OutputStream out, boolean autoFlush) {
        super(out, autoFlush);
    }

    // Specialize

    public void writeGPTree(GPTree gpTree) {

        TreeWalker treeWalker = new TreeWalker();

        treeWalker.depthFirstWalk(gpTree.child);

        writeGraph(treeWalker.nodes, treeWalker.links);
    }

    public void writeNPGraph(NPGraph npGraph) {

        Vector nodes = new Vector();
        Vector links = new Vector();

        // First go, nodes
        Node node = null;
        for (int i = 0; i < npGraph.nodes.length; i++) {
            node = new Node();
            node.id = i;
            node.label = "" + node.id + " : " + npGraph.nodes[i].toString();

            nodes.add(node);
        }

        // Second go, links
        Link link = null;
        for (int i = 0; i < npGraph.nodes.length; i++) {
            for (int j = 0; j < npGraph.nodes[i].links.length; j++) {
                link = new Link();
                link.from = i;
                link.to = npGraph.nodes[i].links[j].position;
                link.label = String.valueOf(j);

                links.add(link);
            }
        }

        writeGraph(nodes, links);
    }

    // Protected
    public abstract void writeGraph(Vector nodes, Vector links);

    protected class TreeWalker {

        Vector nodes = new Vector();
        Vector links = new Vector();

        Node depthFirstWalk(GPNode gpNode) {

            Node node = new Node();

            node.id = nodes.size();
            node.label = "" + node.id + " : " + gpNode.toString();

            nodes.add(node);

            if (gpNode.children.length > 0) {
                Node child = null;
                Link link = null;

                for (int i = 0; i < gpNode.children.length; i++) {

                    child = depthFirstWalk(gpNode.children[i]);

                    link = new Link();
                    link.from = node.id;
                    link.to = child.id;
                    link.label = String.valueOf(i);

                    links.add(link);
                }
            }

            return node;
        }

    }

    public class Node {
        public int id;
        public String label;
        public String attributes;
    }

    public class Link {
        public int from;
        public int to;
        public String label;
        public String attributes;
    }

}


