/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package evision.ec.util;


import java.io.*;

import ec.gp.*;
import evision.ec.np.*;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class Serialized2DOT {
    public static void main(String[] args) {
        if (args.length != 1) {
            System.err.println("Usage: Serialized2DOT <filename>");

            return;
        }

        Object individual;

        try {
            InputStream in = new FileInputStream(args[0]);
            ObjectInputStream ins = new ObjectInputStream(in);

            individual = ins.readObject();

            ins.close();
            in.close();
        }
        catch (Exception e) {
            e.printStackTrace();

            throw new RuntimeException("Error while reading individual " + e);
        }


        if (individual instanceof GPIndividual) {
            writeGPIndividual((GPIndividual) individual, args[0]);
        }
        else if (individual instanceof NPIndividual) {
            writeNPIndividual((NPIndividual) individual, args[0]);
        }
        else {
            throw new RuntimeException("Unknown individual class "
                                       + individual.getClass());

        }

    }

    private static void writeGPIndividual(GPIndividual individual,
                                          String filename) {

        String name = getName(filename);

        for (int i = 0; i < individual.trees.length; i++) {
            try {
                FileOutputStream out = new FileOutputStream(name + "T" + i
                                                            + ".dot");
                DOTWriter writer = new DOTWriter(out, true);

                writer.writeGPTree(individual.trees[i]);

                writer.close();
                out.close();
            }
            catch (IOException e) {
                throw new RuntimeException("Write failure " + e);
            }
        }
    }

    private static void writeNPIndividual(NPIndividual individual,
                                          String filename) {

        String name = getName(filename);

        for (int i = 0; i < individual.graphs.length; i++) {
            try {
                FileOutputStream out = new FileOutputStream(name + "G" + i
                                                            + ".dot");
                DOTWriter writer = new DOTWriter(out, true);

                writer.writeNPGraph(individual.graphs[i]);

                writer.close();
                out.close();
            }
            catch (IOException e) {
                throw new RuntimeException("write failure " + e);
            }
        }

    }

    private static String getName(String s) {
        String name = null;
        int i = s.lastIndexOf('.');

        if (i > 0 && i < s.length() - 1) {
            name = s.substring(0, i);
        }
        else {
            name = s;
        }

        return name;
    }

}

